using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace ComplexNumbers
{
	public class Complex
	{
		double x, y;
		string name;

		public double X { get { return x; } set { x = value; } }
		public double Y { get { return y; } set { y = value; } }
		public string Name { get { return name; } set { name = value; } }

		public double Abs { get { return Math.Sqrt(x * x + y * y); }}

		public Complex(double x, double y, string name)
		{
			this.x = x;
			this.y = y;
			this.name = name;
		}

		public Complex(double x, double y)
		{
			this.x = x;
			this.y = y;
		}

		public Complex()
		{
		}

		public void Invers()
		{
			double r2 = x * x + y * y;
			x = x / r2;
			y = (-y) / r2;
		}

		public void Conjugate()
		{
			y = -y;
		}

		public void WriteToXml(XmlWriter xw)
		{
			xw.WriteStartElement("Point");
			if (name != null && name.Length > 0)
			{
				xw.WriteElementString("Name", name);
			}
			xw.WriteElementString("x", XmlConvert.ToString(x));
			xw.WriteElementString("y", XmlConvert.ToString(y));
			xw.WriteEndElement();
		}

		public void ReadFromXml(XmlNode node)
		{
			XmlNode child;
			child = node.SelectSingleNode("Name");
			if (child != null)
				name = child.InnerText;
			child = node.SelectSingleNode("x");
			x = XmlConvert.ToDouble(child.InnerText);
			child = node.SelectSingleNode("y");
			y = XmlConvert.ToDouble(child.InnerText);
		}

	}
}
